<?php

/*
Plugin Name: WPFTS Addon for BuddyDrive
Description: This plugin allows to extend indexing from different places.
Version: 1.0.2
Tested up to: 5.5.3
Author: Epsiloncool
Author URI: https://e-wm.org
License: GPLv3
License URI: http://www.gnu.org/licenses/gpl-3.0.html
Text Domain: wpfts_lang
Domain Path: /languages/
*/

/**
 *  Copyright 2013-2020 Epsiloncool
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************************************
 *  I am thank you for the help by buying PRO version of this plugin 
 *  at https://fulltextsearch.org/ 
 *  It will keep me working further on this useful product.
 ******************************************************************************
 * 
 *  @copyright 2013-2020
 *  @license GPL v3
 *  @version 1.0.2
 *  @package Wordpress Fulltext Search Pro
 *  @author Epsiloncool <info@e-wm.org>
 */
 
add_filter('wpfts_index_post', function($index, $post)
{
	global $wpfts_core;

	if ($post && $wpfts_core) {
		if ($post->post_type == 'buddydrive-file') {
			$url = $post->guid;
			if (strlen($url) > 0) {
				require_once $wpfts_core->root_dir.'/includes/wpfts_utils.class.php';

				$ret = WPFTS_Utils::GetCachedFileContent_ByLocalLink($url);

				$index['attachment_content'] = isset($ret['post_content']) ? trim($ret['post_content']) : '';
			}
		}	
	}

	return $index;
}, 3, 2);

add_action('pre_get_posts', function(&$wpq)
{
	if ($wpq->is_main_query() && $wpq->is_search) {
		
		// Justify post_type
		$pt = $wpq->get('post_type');
		if ($pt && ($pt != 'any')) {
			//
		} else {
			$pt = get_post_types(array('exclude_from_search' => false));
		}
		if (!is_array($pt)) {
			if (strlen($pt) > 0) {
				$pt = array($pt);
			} else {
				$pt = array();
			}
		}
		if (in_array('attachment', $pt)) {
			// Search in files are enabled
			$pt = array_merge(array('buddydrive-file'), $pt);
			$wpq->query_vars['post_type'] = $pt;
		}

		// Justify post_status
		$st = $wpq->get('post_status');
		if ($st) {
			//
		} else {
			$st = array('publish');
		}
		if (!is_array($st)) {
			if (strlen($st) > 0) {
				$st = array($st);
			} else {
				$st = array();
			}
		}
		if (in_array('inherit', $st)) {
			$st = array_merge(array('buddydrive_public'), $st);
			$wpq->query_vars['post_status'] = $st;
		}
	}
}, 20);

add_filter('wpfts_se_titlelink', function($r1, $post)
{
	if ($post && ($post['post_type'] == 'buddydrive-file')) {
		$r1['is_demo'] = 0;
		$r1['is_attachment'] = 1;
		$r1['is_title_direct_link'] = 1;
		$r1['link'] = $post['guid'];
	}

	return $r1;
}, 10, 2);
